colnames(dat)<-c("Id","bott","fs", "S_Sa", "S_Cu" ,"W_Sa" ,"W_Cu","Pi_Sa" ,"Pi_Cu","Pi_inter","Fst_Nei","D_Sa","D_Cu", "H_Sa","H_Cu")


ID<-as.numeric(levels(as.factor(dat$Id)))

Sim1<-data.frame()
for(j in 1:length(ID)){
	
	st<-dat[dat$Id == ID[j],]
	
	nosel<-st[st$fs == "nosel",]
	sel<-st[st$fs == "sel",]

	f=length(sel$fs)/(length(nosel$fs)+length(sel$fs))
	
	print(paste("i=", j, "f=", f))
	
  st<-rbind(nosel, sel)

	
	## discard when S_cu has not polymorphism and not fixed derived allele
	
	for(i in 1:length(st$fs)){

		if(st$D_Cu[i] == -999 && !is.na(st$D_Cu[i])){
			st$D_Cu[i]<-NA
		}
		if(st$D_Sa[i] == -999 && !is.na(st$D_Sa[i])){
		 st$D_Sa[i]<-NA
		}
		if(st$H_Cu[i] == 0 && !is.na(st$H_Cu[i])){
			st$H_Cu[i]<-NA
		}
		if(st$H_Sa[i] == 0 && !is.na(st$H_Sa[i])){
		 st$H_Sa[i]<-NA
		}
# 		if(st$Fst[i] == -999 && !is.na(st$Fst[i])){
# 		 st$Fst[i]<-NA
# 		}
	}

	### summary stat
	# sum and variance of segregating sites
	S_Cu<-sum(st$S_Cu, na.rm=TRUE)
	S_Sa<-sum(st$S_Sa, na.rm=TRUE)

	var_S_Cu<-var(st$S_Cu, na.rm=TRUE)
	var_S_Sa<-var(st$S_Sa, na.rm=TRUE)

	W_Cu<-mean(st$W_Cu, na.rm=TRUE)
	W_Sa<-mean(st$W_Sa, na.rm=TRUE)

	P_Cu<-mean(st$Pi_Cu, na.rm=TRUE)
	P_Sa<-mean(st$Pi_Sa, na.rm=TRUE)

	fstHudson<-1-((st$Pi_Cu+st$Pi_Sa)/2)/st$Pi_inter

	Fst<-mean(fstHudson, na.rm=TRUE)

	D_Cu<-mean(st$D_Cu, na.rm=TRUE)
	D_Sa<-mean(st$D_Sa, na.rm=TRUE)

	var_D_Cu<-var(st$D_Cu, na.rm=TRUE)
	var_D_Sa<-var(st$D_Sa, na.rm=TRUE)


	H_Cu<-sum(st$H_Cu, na.rm=TRUE)
	H_Sa<-sum(st$H_Sa, na.rm=TRUE)
	

	bott<-st$bott[1]
	Sim<-data.frame(ID[j], bott, f, S_Cu, S_Sa, var_S_Cu, var_S_Sa, W_Cu, W_Sa, 
		P_Cu, P_Sa, D_Cu, D_Sa, var_D_Cu, var_D_Sa, Fst, H_Cu, H_Sa)
	Sim1<-rbind(Sim1, Sim)
}

