#!/usr/bin/perl -w

sub round {
    my($number) = shift;
    return int($number + .5 * ($number <=> 0));
}


my $newdir = $ARGV[0];
my $N_simul = $ARGV[1];

my $outStat = $ARGV[2];
my $outParams = $ARGV[3];
my $simulID = $ARGV[4];

# my $N_loci = $ARGV[5];
my $N_loci = 0;
my $SizeFile = $ARGV[5];

system("rm $newdir/$outStat");

open PAR, "> $newdir/$outParams";

for(my $i = 0; $i<$N_simul; $i++){
	
	$N_loci = 0;
	
	## sample size
	my $n_out = 9;
	my $n_in = 7;

	my $mu = 10**(-8);

	# Prior on N
	my $N =  round(20000+rand(120000));
	
# 	my $N_loci  = 324; # see $ARGV[6]
	
	## porportion of ancestral population during the bottleneck
	my $k = rand(0.2)+0.001;
# 	my $k = 0.15;
# 
	## fix split age at 3000 gene (3000/(4*Ne))
	my $t_split = 3000/(2.0*$N);

	### Fix the duration of the bottleneck to 1000 generation
	### assuming an ancestral pop of 10,000, 0.025*(4*1000) = 1000 generation
	my $t_bott = $t_split-(1000/(2.0*$N));
	
	print PAR "$k,$t_split,$t_bott,$mu,$N\n";
	
	open PARAM, ">$newdir/Param.$simulID";
	open SIZE, "<$SizeFile";
	while(my $size = <SIZE>){
		chomp($size);
		$N_loci++;
		my $newtheta = $N * $mu * $size;
		print PARAM "$newtheta\n";
	}
	close SIZE;
	close PARAM;
	
	open SID, "> $newdir/Ids.$simulID.csv";
	### all the simul have the same IDs
	for(my $j = 0; $j<$N_loci; $j++){
		print SID "$i\n";
	}
	close SID;

	my $R1 = int(rand(9999));
	my $R2 = int(rand(9999));
	my $R3 = int(rand(9999));

	my $N_tot = $n_in+$n_out;

	## Add an ancestral population expansion for wild population
 	#print "~/bin/ms $N_tot $N_loci -seeds $R1 $R2 $R3 -t tbs -I 2 $n_out $n_in -n 2 1.0 -ej $t_split 2 1 -en $t_bott 2 $k >$newdir/res.$simulID <$newdir/Param.$simulID\n";

	system("rm $newdir/res.$simulID");

# 	system("~/bin/ms $N_tot $N_loci -seeds $R1 $R2 $R3 -t tbs -I 2 $n_out $n_in -n 2 1.0 -ej $t_split 2 1 -en $t_bott 2 $k >$newdir/res.$simulID <$newdir/Theta.$simulID");
	system("ms $N_tot $N_loci -seeds $R1 $R2 $R3 -t tbs -I 2 $n_out $n_in -n 2 1.0 -ej $t_split 2 1 -en $t_bott 2 $k >$newdir/res.$simulID <$newdir/Param.$simulID");

	################ modif result file
	my $file = "$newdir/res.$simulID";
	if(-f "$file"){
		open F, $file;
	}else{
		die "$file does not exit!\n"
	}

	open F, "$file";
	open NEW, ">> $newdir/tmp.$simulID";
	my $co = 0;
	while(my $line = <F>){
		chomp($line);
		$co = $co + 1;
		if($co < 3 || $line =~ /^\/home/){
			next;
		}
		if($line =~ /^ms/){
			$co=1;
			print NEW "$line\n";
			next;
		}
		if($line =~ /\/\// && $line =~ /-N/){
			my @ar = split("\t", $line);
			print NEW "//\tsel\t$ar[23]\n";
			next;
		}
		if($line =~ /\/\//){
			$line =~ s/\/\///;
			print NEW "//\tnosel\t$k\t$N_tot\n";
			next;
		}
# 	if($line !~ /^ms/ && $line !~ /^segsites/ && $line !~ /^positions/){
# 		$line =~ s/0/A/g;
# 		$line =~ s/1/T/g;
# 		print NEW "$line\n";
# 		next;
# 	}
		print NEW "$line\n";
	}
	close F;
	close NEW;
	system("mv $newdir/tmp.$simulID $newdir/res.$simulID");

	### summary statistic
 	system("./seq_stat_2pop_from_MS $newdir/res.$simulID $n_out $newdir/Ids.$simulID.csv >>$newdir/$outStat");

}
close PAR;
exit 0;
